;===========================================
; File : ESC.ASM  (c) G. Born
;
; Programm zur Ausgabe von Zeichen an die
; Standardausgabeeinheit. Das Programm wird
; z.B. mit: ESC 0D,0A,1B "Hallo"
; von der DOS-Kommandoebene aufgerufen und
; gibt die spezifizierten Codes aus.
;===========================================
;
       RADIX 16            ; Hexadezimalsystem
       CODE SEGMENT
       Blank EQU 20        ; Blank
       EXTRN HexAsc:NEAR   ; externe Module
       EXTRN String:NEAR
       EXTRN Number:NEAR
       EXTRN Skip:NEAR

; Sprung ins Hauptprogramm
MAIN:  JMP Near Start      ; Next
;
;===========================================
; Definition des Stacksegmentes
;===========================================
;
Stack SEGMENT WORD STACK
  DW 100 DUP (?)           ; reserviere Stack
Stack ENDS
;
       CODE SEGMENT
;
;===========================================
; Hauptprogramm
;===========================================
; prfe ob Parameter vorhanden sind
;
Start: MOV AX,CS
       MOV DS,AX       ; DS = CS !
       CMP BYTE [80],0 ; Text vorhanden
       JZ  Endm1       ; kein Text vorhanden
       XOR CX,CX       ; clear Counter
       MOV CL,[80]     ; lade Pufferlnge
       MOV DI,0081     ; lade Puffer Offset
Loopb:                 ; gebe Parameter aus
       AND CX,CX       ; Ende erreicht ?
       JZ Endm1        ; DOS-Exit
       CALL NEAR Skip  ; CALL Skip
       JC Endm1        ; DOS-Exit
       CALL NEAR String; CALL String
       JC Endm1        ; DOS-Exit
       CALL NEAR Skip  ; CALL Skip
       JC Endm1        ; DOS-Exit
       CALL NEAR Number; CALL Number
       JC Endm1        ; DOS-Exit
       JMP SHORT Loopb ; JMP Loop
;
; DOS-Exit, Returncode in AL
;
Endm1: MOV AX,4C00     ; DOS Exitcode
       INT 21
;
       END MAIN

