;===========================================
; File : ESC.ASM  (c) G. Born
; Version: 1.0 (TASM)
; Programm zur Ausgabe von Zeichen an die
; Standardausgabeeinheit. Das Programm wird
; z.B. mit: ESC 0D,0A,1B "Hallo"
; von der DOS-Kommandoebene aufgerufen und
; gibt die spezifizierten Codes aus.
;===========================================
;
       .MODEL SMALL
       .RADIX 16           ; Hexadezimalsystem

       Blank EQU 20        ; Blank

       EXTRN HexAsc:NEAR   ; externe Module
       EXTRN String:NEAR
       EXTRN Number:NEAR
       EXTRN Skip:NEAR

;===========================================
; Definition des Stacksegmentes
;===========================================
       .STACK 200H

       .CODE
;
;===========================================
; Hauptprogramm
;===========================================
;
Start: MOV AH,51       ; ermittle Adr. PSP
       INT 21          ; "
       MOV ES,BX       ; ES = Adr. PSP !
       MOV CL,ES:[80]  ; lade Pufferlnge
       CMP CL,0        ; Text vorhanden
       JZ  Endx        ; kein Text vorhanden
       XOR CH,CH       ; clear Counter Hbyte
       MOV DI,0081     ; lade Puffer Offset
Loopb:                 ; gebe Parameter aus
       AND CX,CX       ; Ende erreicht ?
       JZ Endx         ; DOS-Exit
       CALL Skip       ; Separatoren berlesn
       JC Endx         ; DOS-Exit
       CALL String     ; String ausgeben
       JC Endx         ; DOS-Exit
       CALL Skip       ; Separ. berlesen
       JC Endx         ; DOS-Exit
       CALL Number     ; Zahl ausgeben
       JC Endx         ; DOS-Exit
       JMP Loopb       ; next Param.
;
; DOS-Exit, Returncode in AL
;
Endx:  MOV AX,4C00     ; DOS Exitcode
       INT 21
;
       END Start

